com.io7m.jstructural.core

## Class SDocument

- java.lang.Object
- - com.io7m.jstructural.core.SDocument

- Direct Known Subclasses:
    SDocumentWithParts, SDocumentWithSections

      @Immutable
      public abstract class SDocument
      extends Object

  A document.

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SDocument(SDocumentTitle in_title, com.io7m.jfunctional.OptionType<SDocumentContents> in_contents, com.io7m.jfunctional.OptionType<SDocumentStyle> in_style)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract <D> D` | `documentAccept(SDocumentVisitor<D> v)` Accept a document visitor.
    `boolean` | `equals(Object obj)`
    `com.io7m.jfunctional.OptionType<SDocumentContents>` | `getContents()`
    `com.io7m.jfunctional.OptionType<SDocumentStyle>` | `getStyle()`
    `SDocumentTitle` | `getTitle()`
    `int` | `hashCode()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### SDocument

          protected SDocument(SDocumentTitle in_title,
                              com.io7m.jfunctional.OptionType<SDocumentContents> in_contents,
                              com.io7m.jfunctional.OptionType<SDocumentStyle> in_style)

  - ### Method Detail

    - #### documentAccept

          public abstract <D> D documentAccept(SDocumentVisitor<D> v)
                                        throws Exception

      Accept a document visitor.
      Type Parameters:
        `D` - The type of transformed `SDocument`s
      Parameters:
        `v` - The visitor
      Returns:
        The value returned by the visitor
      Throws:
        `Exception` - If the visitor raises an `Exception`

    - #### equals

          public boolean equals(@Nullable
                                Object obj)

      Overrides:
        `equals` in class `Object`

    - #### getContents

          public final com.io7m.jfunctional.OptionType<SDocumentContents> getContents()

      Returns:
        The document contents

    - #### getStyle

          public final com.io7m.jfunctional.OptionType<SDocumentStyle> getStyle()

      Returns:
        The document style

    - #### getTitle

          public final SDocumentTitle getTitle()

      Returns:
        The document title

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

Copyright © 2015 <code@io7m.com> http://io7m.com